/*
  adc.c - Test AT91 ADCs

  Copyright (c) 2008-2010 Micromint USA LLC
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
  * Neither the name of Micromint USA LLC nor the names of its
    contributors may be used to endorse or promote products derived
    from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
  COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
  DAMAGE.

  AT91 built-in ADCs

  Header PIO   Alt
  ------ ---   ---
  J2-18  PC0   AD0
  J2-19  PC1   AD1
  J2-20  PC3   AD2
  J2-21  PC4   AD3
*/

#include "board.h"

#define ADC_VREF       3300  // 3.3 * 1000

//-----------------------------------------------------------------------------
/// Convert a digital value in milivolt
/// /param valueToconvert Value to convert in milivolt
//-----------------------------------------------------------------------------
static unsigned int ConvHex2mV( unsigned int valueToConvert )
{
    return( (ADC_VREF * valueToConvert)/0x3FF);
}

int main(int argc, char **argv)
{
  unsigned int i;

  printf("adc - Read ADCs\n");
  /* Initialize board */
  if (boardInit() < 0)
    {
      printf("ERROR: Unable to initialize board\n");
      return -1;
    }

  /* Read ADC 10 times */
  for (i = 0; i < 10; i++)
    {
      /* Read ADCs */
      ADC_StartConversion(AT91C_BASE_ADC);
      usleep(1000);
      printf("ADC %d: %d mV\n\r", 0,
              ConvHex2mV(ADC_GetConvertedData(AT91C_BASE_ADC, ADC_CHANNEL_0)));

      /* wait for about 100 ms */
      usleep(100000);
  }
  printf("ADC test completed\n");
}

